#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct {
    char jmeno[31];
    int tel;
}kartoteka;

int nactiKontakty(kartoteka kart[100]);
kartoteka najdi(char jmeno[31],kartoteka kart[100],int pocet);
void vypis(kartoteka kart[100],int pocet);

void zapis(kartoteka kart[100],int pocet, FILE *f);
int nacti(kartoteka kart[100],FILE *f);

int main()
{
    kartoteka kart[100],os;
    FILE *f;
    int pocet;
    char jmeno[31];



    f = fopen("kartoteka.dat","r+b");
    if(f == NULL){
         f = fopen("kartoteka.dat","w+t");
         pocet = nactiKontakty(kart);
         zapis(kart,pocet,f);
    }

    pocet = nacti(kart,f);
    vypis(kart,pocet);
    printf("Jmeno hledane osoby:");
    fgets(jmeno,31,stdin);
    char *nl = strchr(jmeno,'\n');
    if(nl != NULL){
        *nl = 0;
    }

    os = najdi(jmeno,kart,pocet);

    if(os.tel >-1){
        printf("%s: %d",os.jmeno,os.tel);
    }else{
        printf("Kontakt na tuto osobu chybi.");
    }

    fclose(f);
    return 0;
}

int nactiKontakty(kartoteka kart[100]){
    kartoteka kontakt;
    int i = 0;
    do{
        printf("jmeno: ");
        fgets(kontakt.jmeno,30,stdin);
        char *pos = strchr(kontakt.jmeno, '\n');
        if(pos!=NULL){
            *pos = '\0';
        }
        if(strlen(kontakt.jmeno)>0){
            printf("telefon: ");
            scanf("%d",&kontakt.tel);
            kart[i] = kontakt;
            i++;
            getchar();
        }

    }while(strlen(kontakt.jmeno)>0);
    return i;
}

kartoteka najdi(char jmeno[31],kartoteka kart[100],int pocet){
    int i;
    kartoteka chyba = {"",-1};
    for(i=0;i<pocet;i++){
      if(strcmp(jmeno,kart[i].jmeno)==0){
        return kart[i];
      }
    }
    return chyba;
}

void vypis(kartoteka kart[100],int pocet){
    int i;
    for (i=0;i<pocet;i++)
    {
        printf("jmeno: %s, telefon: %d\n", kart[i].jmeno, kart[i].tel);
    }
}

void zapis(kartoteka kart[100],int pocet,FILE *f)
{
    fwrite(kart,sizeof(kartoteka),pocet,f);
    fflush(f);

}

int nacti(kartoteka kart[100],FILE *f)
{
    int i=0;
    kartoteka pom;
    while(!feof(f)){
        fread(&pom,sizeof(kartoteka),1,f);
        if(!feof(f)){
            kart[i] = pom;
            i++;
        }

    }
    return i;
}
